﻿var g_feedManagerProgID		= "Microsoft.FeedsManager";
var g_feedManager		= null;
var station;
var g_page;
var g_maxPage;
var g_feed;

function loadMain()
{
	setTimeout(loadData, 1000);
}

function loadData()
{
	loadFeedManager();
	initFeed();
	setTimeout(reload, 600000);
}

function goForward()
{
	var title;
	if (g_page === 0)
		g_page = g_maxPage-1;
	else
	{
		if (g_page === g_maxPage-1)
		{
			do
			{
				g_page = g_page - 1;
				title = g_feed.Items.item(g_page).Title;
			}
			while (title.search("Forecast")<0);
		}
		else
		{
			g_page = g_page - 1;
			if (g_feed.Items.item(g_page).Title.search("Forecast")<0)
				g_page = g_maxPage-1;
		}
	}
	showItem();
}

function goBackward()
{
	var title;
	var jmpneed = 0;
	title = g_feed.Items.item(g_page).Title;
	if (title.search("Forecast")>=0)
		jmpneed = 1;
	g_page = g_page + 1;
	if (g_page === g_maxPage)
	{
		do	{
			g_page = g_page - 1;
			title = g_feed.Items.item(g_page).Title;
		}
		while (title.search("Forecast")<0);
		do	{
			g_page = g_page - 1;
			title = g_feed.Items.item(g_page).Title;
		}
		while (title.search("Forecast")>=0 && g_page != 0);
		if (g_page != 0)
			g_page = g_page + 1;
	}
	title = g_feed.Items.item(g_page).Title;
	if (title.search("Forecast")<0 && jmpneed)
		g_page = g_maxPage-1;
	showItem();
}

function loadFeedManager()
{        
    // Make sure we have a handle to the feed manager
    if (g_feedManager == null)
    {
        try
        {
            g_feedManager = new ActiveXObject(g_feedManagerProgID);
            if (g_feedManager == null)
            {
		debug.innerText = "No Feed Manager!";
                return null;
            }
//	    else
//		debug.innerText = "Success 2!";
         }
         catch(e)
         {
		debug.innerText = "No Feed Manager!";
		g_timerFlag = false;
         }
    }    
}

function showItem()
{
	var currCond = g_feed.Items.item(g_page).Description;
	var currTitle = g_feed.Items.item(g_page).Title;
	var night = 0;

	if (g_page === g_maxPage - 1)
	{
		var d = new Date();
		if (d.getHours() >= 21 || d.getHours() <= 6)
			night = 1;
		else
			night = 0;

		dow.innerText = "Today";
	}
	else
	{
		if (currTitle.search("Night")>=0)
			night = 1;

		var ind = currTitle.search("for ")+4;
		dow.innerText = currTitle.substr(ind, currTitle.search("as of") - ind);
	}

	//weather condition pictures
	if (currCond.search("Clear") >= 0 || currCond.search("Sunny") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_clear.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/sunny.GIF)";
	}
	if (currCond.search("Cloudy") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_cloudy.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/cloudy.GIF)";
	}
	if (currCond.search("Flurries") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_flurries.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/flurries.GIF)";
	}
	if (currCond.search("Fog") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_fog.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/fog.GIF)";
	}
	if (currCond.search("Hazy") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_hazy.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/hazy.GIF)";
	}
	if (currCond.search("Scattered Clouds") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_mostlysunny.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/mostlysunny.GIF)";
	}
	if (currCond.search("Partly Cloudy") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_partlycloudy.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/partlycloudy.GIF)";
	}
	if (currCond.search("Mostly Cloudy") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_mostlycloudy.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/mostlycloudy.GIF)";
	}
	if (currCond.search("Rain") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_rain.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/rain.GIF)";
	}
	if (currCond.search("Chance of Rain") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_chancerain.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/chancerain.GIF)";
	}
	if (currCond.search("Overcast") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_cloudy.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/cloudy.GIF)";
	}
	if (currCond.search("Snow") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_snow.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/snow.GIF)";
	}
	if (currCond.search("Chance of Snow") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_chancesnow.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/chancesnow.GIF)";
	}
	if (currCond.search("Thunderstorms") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_tstorms.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/tstorms.GIF)";
	}
	if (currCond.search("Chance of Thunderstorms") >= 0)
	{
		if (night)
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/nt_chancetstorms.GIF)";
		else
			picture.src = "url(http://icons-aa.wunderground.com/graphics/conds/chancetstorms.GIF)";
	}


	var pind = currCond.indexOf("/")+2;
	var tempr;
	if (g_page === g_maxPage - 1)
		tempr = currCond.substr(pind, currCond.indexOf("|")-pind);
	else
		tempr = currCond.substr(pind, currCond.indexOf("° C.")-pind+3);

	tempr = tempr.replace(" ", "");
	tempr = tempr.replace(" ", "");
	temperature.innerText = tempr;

	forward.src = "images/forward.png";
	backward.src = "images/backward.png";
	reloadimg.src = "images/reload.png";
}

function initFeed()
{
	timerID = setTimeout(initFeed, 5000);
	if (g_feedManager.ExistsFeed("Wunderground"))
		g_feedManager.DeleteFeed("Wunderground");
//	if (!g_feedManager.ExistsFeed("Wunderground"))
	g_wundergroundUrl = "http://www.wunderground.com/auto/rss_full/global/stations/"+station+".xml?units=metric";
	g_feedManager.RootFolder.CreateFeed("Wunderground", g_wundergroundUrl);
	g_feed = g_feedManager.GetFeed("Wunderground");
	if (g_feed)
	{
		g_feed.Download();
		debug.innerText = "loaded";
		g_maxPage = g_feed.Items.Count;
		if(g_maxPage > 0)
		{
			g_page = g_maxPage-1;
			showItem();
			debug.innerText = "";
		}
		clearTimeout(timerID);
	}
}

function loadUrl() {
	System.Shell.execute("http://www.wunderground.com/global/stations/"+station+".html");
}

function reload() {
	g_feed.Download();
	g_maxPage = g_feed.Items.Count;
	g_page = g_maxPage - 1;
	showItem();
	setTimeout(reload, 600000);
}

function setStation(stationNr)
{
	station = stationNr;
}